#!/usr/bin/env scheme-script
;; -*- mode: scheme; coding: utf-8 -*- !#
;; Copyright (c) 2024 Vadym Kochan
;; SPDX-License-Identifier: MIT
#!r6rs

(import (rnrs (6))
        (srfi :64 testing)
        (image png)
        (image private zlib))

(define test-png-port  
  (open-bytevector-input-port #vu8(#x89 #x50 #x4e #x47 #x0d #x0a #x1a #x0a #x00 #x00 #x00 #x0d
  #x49 #x48 #x44 #x52 #x00 #x00 #x00 #x0a #x00 #x00 #x00 #x0a
  #x08 #x02 #x00 #x00 #x00 #x02 #x50 #x58 #xea #x00 #x00 #x01
  #x84 #x69 #x43 #x43 #x50 #x49 #x43 #x43 #x20 #x70 #x72 #x6f
  #x66 #x69 #x6c #x65 #x00 #x00 #x28 #x91 #x7d #x91 #x3d #x48
  #xc3 #x40 #x1c #xc5 #x5f #x53 #xa5 #x22 #x15 #x07 #x8b #x88
  #x3a #x64 #x68 #x9d #x2c #x88 #x8a #x38 #x6a #x15 #x8a #x50
  #x21 #xd4 #x0a #xad #x3a #x98 #x5c #xfa #x21 #x34 #x69 #x48
  #x52 #x5c #x1c #x05 #xd7 #x82 #x83 #x1f #x8b #x55 #x07 #x17
  #x67 #x5d #x1d #x5c #x05 #x41 #xf0 #x03 #xc4 #xcd #xcd #x49
  #xd1 #x45 #x4a #xfc #x5f #x52 #x68 #x11 #xe3 #xc1 #x71 #x3f
  #xde #xdd #x7b #xdc #xbd #x03 #x84 #x7a #x99 #x69 #x56 #xc7
  #x18 #xa0 #xe9 #xb6 #x99 #x4e #x26 #xc4 #x6c #x6e #x45 #x0c
  #xbd #x22 #x8c #x21 #xf4 #x23 #x86 #x90 #xcc #x2c #x63 #x56
  #x92 #x52 #xf0 #x1d #x5f #xf7 #x08 #xf0 #xf5 #x2e #xce #xb3
  #xfc #xcf #xfd #x39 #x7a #xd4 #xbc #xc5 #x80 #x80 #x48 #x3c
  #xc3 #x0c #xd3 #x26 #x5e #x27 #x9e #xda #xb4 #x0d #xce #xfb
  #xc4 #x11 #x56 #x92 #x55 #xe2 #x73 #xe2 #x51 #x93 #x2e #x48
  #xfc #xc8 #x75 #xc5 #xe3 #x37 #xce #x45 #x97 #x05 #x9e #x19
  #x31 #x33 #xe9 #x39 #xe2 #x08 #xb1 #x58 #x6c #x63 #xa5 #x8d
  #x59 #xc9 #xd4 #x88 #x27 #x89 #xa3 #xaa #xa6 #x53 #xbe #x90
  #xf5 #x58 #xe5 #xbc #xc5 #x59 #x2b #x57 #x59 #xf3 #x9e #xfc
  #x85 #xe1 #xbc #xbe #xbc #xc4 #x75 #x9a #xc3 #x48 #x62 #x01
  #x8b #x90 #x20 #x42 #x41 #x15 #x1b #x28 #xc3 #x46 #x9c #x56
  #x9d #x14 #x0b #x69 #xda #x4f #xf8 #xf8 #x07 #x5d #xbf #x44
  #x2e #x85 #x5c #x1b #x60 #xe4 #x98 #x47 #x05 #x1a #x64 #xd7
  #x0f #xfe #x07 #xbf #xbb #xb5 #x0a #x13 #xe3 #x5e #x52 #x38
  #x01 #x74 #xbe #x38 #xce #x47 #x0c #x08 #xed #x02 #x8d #x9a
  #xe3 #x7c #x1f #x3b #x4e #xe3 #x04 #x08 #x3e #x03 #x57 #x7a
  #xcb #x5f #xa9 #x03 #xd3 #x9f #xa4 #xd7 #x5a #x5a #xf4 #x08
  #xe8 #xdd #x06 #x2e #xae #x5b #x9a #xb2 #x07 #x5c #xee #x00
  #x03 #x4f #x86 #x6c #xca #xae #x14 #xa4 #x29 #x14 #x0a #xc0
  #xfb #x19 #x7d #x53 #x0e #xe8 #xbb #x05 #xba #x57 #xbd #xde
  #x9a #xfb #x38 #x7d #x00 #x32 #xd4 #x55 #xea #x06 #x38 #x38
  #x04 #x46 #x8a #x94 #xbd #xe6 #xf3 #xee #xae #xf6 #xde #xfe
  #x3d #xd3 #xec #xef #x07 #x73 #x8f #x72 #xa7 #x5e #x80 #xf1
  #x2d #x00 #x00 #x00 #x09 #x70 #x48 #x59 #x73 #x00 #x00 #x2e
  #x23 #x00 #x00 #x2e #x23 #x01 #x78 #xa5 #x3f #x76 #x00 #x00
  #x00 #x07 #x74 #x49 #x4d #x45 #x07 #xe5 #x0c #x1c #x07 #x36
  #x21 #x95 #x58 #xb2 #x19 #x00 #x00 #x00 #x19 #x74 #x45 #x58
  #x74 #x43 #x6f #x6d #x6d #x65 #x6e #x74 #x00 #x43 #x72 #x65
  #x61 #x74 #x65 #x64 #x20 #x77 #x69 #x74 #x68 #x20 #x47 #x49
  #x4d #x50 #x57 #x81 #x0e #x17 #x00 #x00 #x00 #x24 #x49 #x44
  #x41 #x54 #x18 #xd3 #x63 #xcc #xc9 #x69 #x62 #xc0 #x0d #x18
  #x3f #x1d #x51 #xc3 #x23 #xcd #x52 #xb5 #x22 #x06 #x8f #x34
  #x13 #x03 #x5e #x40 #x53 #xc3 #x69 #x6a #x37 #x00 #xf9 #x64
  #x0b #x7f #x63 #x7a #x17 #xda #x00 #x00 #x00 #x00 #x49 #x45
  #x4e #x44 #xae #x42 #x60 #x82)))

(test-begin "png basic")
(let* ([png (read-png test-png-port)])
  (test-equal #t (png? png))
  (test-equal 10 (png-width png))
  (test-equal 10 (png-height png))
  (test-equal 8 (png-color-bits png))
  (test-equal 'rgb (png-color-type png))
)
(test-end)

(test-begin "png read/write")
(let* ([img #vu8(1 2 3  1 2 3  1 2 3
		 2 3 4  2 3 4  3 5 6)])
  (let-values ([(outp get-bytes) (open-bytevector-output-port)])
    (let ([png (make-png 3 2 8 'rgb img)])
      (write-png png outp))
    (call-with-port (open-bytevector-input-port (get-bytes))
      (lambda (inp)
        (close-port outp)
        (let ([png (read-png inp)])
          (test-equal 3 (png-width png))
          (test-equal 2 (png-height png))
          (test-equal 8 (png-color-bits png))
          (test-equal img (png-data png))))))
)
(test-end)

(test-begin "png write-chunks")
(let* ([img #vu8(1 2 3  1 2 3  1 2 3
		 2 3 4  2 3 4  3 5 6)])
  (let-values ([(outp get-bytes) (open-bytevector-output-port)])
    (write-png-chunks
      (list (make-ihdr-chunk 3 2 8 PNG-COLOR-TYPE-RGB) ;; width, height, bits, type
            (make-idat-chunk 3 2 3 img))  ;; width, height, pixel size, data
      outp)
    (call-with-port (open-bytevector-input-port (get-bytes))
      (lambda (inp)
        (close-port outp)
        (let ([png (read-png inp)])
          (test-equal 3 (png-width png))
          (test-equal 2 (png-height png))
          (test-equal 8 (png-color-bits png))
          (test-equal img (png-data png))))))
)
(test-end)

(test-begin "zlib compress with single block")
(let* ([bytes (make-bytevector (fx+ (fx* 32 1024) 1) 123)]
       [comp (zlib-compress bytes)]
       [decomp (zlib-decompress comp)])
  (test-equal bytes decomp)
)
(test-end)

(test-begin "zlib compress with multiple blocks")
(let* ([bytes (make-bytevector (* 300 400 3) 123)]
       [comp (zlib-compress bytes)]
       [decomp (zlib-decompress comp)])
  (test-equal bytes decomp)
)
(test-end)

(exit (if (zero? (test-runner-fail-count (test-runner-get))) 0 1))
